stages:
  - parse_docs
  - export_docs
  - build_site

parse:
  # Based on https://vuepress.vuejs.org/guide/deploy.html#gitlab-pages-and-gitlab-ci
  image: node:10.22.0
  stage: parse_docs
  cache:
    paths:
      - node_modules/
  script:
    # Parse Markdow-files that are referenced in SUMMARY.md to VuePress Default Theme Config
    # Including a site.md to build exports
    - npm install https://gitlab.com/istddev/pub-tools/mdbook.git
    - npx mdbook parse . docs
  artifacts:
    paths:
      - docs
  only:
    - web
    - tags

export:
  # Based on https://gitlab.com/pandoc/pandoc-ci-example#advanced-usage
  image:
    name: pandoc/latex
    entrypoint: ["/bin/sh", "-c"]
  stage: export_docs
  # Provide access to docs (created in parse-job)
  needs: ["parse"]
  # Create site-exports
  script:
    - mkdir exports
    - cd docs
    - pandoc site.md --toc --pdf-engine=xelatex -o ../exports/$CI_PROJECT_NAME.pdf
    - pandoc site.md -o ../exports/$CI_PROJECT_NAME.epub
  artifacts:
    paths:
      - exports
  only:
    - web
    - tags

pages:
  # based on https://vuepress.vuejs.org/guide/deploy.html#gitlab-pages-and-gitlab-ci
  image: node:10.22.0
  stage: build_site
  cache:
    paths:
      - node_modules/
  # Provide access to docs (created in parse-job)
  # Provide access to site-exports (created in export-job)
  needs: ["parse", "export"]
  script:
    # Install MdBook VuePress Template dependencies
    - npm install https://gitlab.com/istddev/pub-tools/mdbook.git
    - npx mdbook vuepress
    # Build VuePress site to Publish
    - npx vuepress build docs
    # Copy site-exports to Publish
    - cp exports/* public
  artifacts:
    paths:
      - public
  only:
    - web
    - tags
